//+------------------------------------------------------------------+
//|                                                                  |
//|                    _Close_ALL_Orders.mq4                         |
//|                                                                  |
//+------------------------------------------------------------------+
//
//31March2009/ref: http://forum.mql4.com/20936
//below source added to... slightly :)
/*
my getOutClause:
0. ANY public code can prove hazardous to your account.
1. please test yourself on demo account by placing many and various types of order types...
2. satisfy yourself that this script will work for you prior to using on LIVE account.
   IE, it is your total responsibility should the script not work as you expected...
3. IF not satisfied THEN hack to suit...; GOTO (1)
4. time to smile :o)
*/
#include <stdlib.mqh>
#define ISTRADEALLOWED_POLLMSECS 500
#define RETRY_MAX 3
string sOrderType(int iType)
{
  string s="UNKNOWN";
  switch(iType) {
    case OP_BUY: s = "OP_BUY"; break;
    case OP_SELL: s = "OP_SELL"; break;
    case OP_BUYLIMIT: s = "OP_BUYLIMIT"; break;
    case OP_SELLLIMIT: s = "OP_SELLLIMIT"; break;
    case OP_BUYSTOP: s = "OP_BUYSTOP"; break;
    case OP_SELLSTOP: s = "OP_SELLSTOP";
  }
  return(s);
}//sOrderType()
/*
<<TEST RESULTS>>
2009.03.31 11:49:10	_Close_ALL_Orders EURUSD,M15: removed
2009.03.31 11:49:10	_Close_ALL_Orders EURUSD,M15: uninit reason 0
2009.03.31 11:49:10	_Close_ALL_Orders EURUSD,M15: close #43515109 sell 0.01 USDCHF at 1.13772 at price 1.13828
2009.03.31 11:49:10	_Close_ALL_Orders EURUSD,M15: delete #43515124 buy stop 0.01 USDCHF at 1.13879 sl: 1.13769 tp: 1.13929 ok
2009.03.31 11:49:10	_Close_ALL_Orders EURUSD,M15: delete #43515134 sell stop 0.01 USDJPY at 98.362 sl: 98.472 tp: 98.312 ok
2009.03.31 11:49:10	_Close_ALL_Orders EURUSD,M15: close #43515142 buy 0.01 USDJPY at 98.435 at price 98.382
2009.03.31 11:49:10	_Close_ALL_Orders EURUSD,M15: delete #43515151 buy stop 0.01 EURUSD at 1.33409 sl: 1.33299 tp: 1.33459 ok
2009.03.31 11:49:09	_Close_ALL_Orders EURUSD,M15: delete #43515155 sell stop 0.01 EURUSD at 1.33292 sl: 1.33402 tp: 1.33242 ok
2009.03.31 11:49:09	_Close_ALL_Orders EURUSD,M15: close #43515218 sell 0.01 EURUSD at 1.33322 at price 1.33340
2009.03.31 11:49:08	_Close_ALL_Orders EURUSD,M15 inputs: Slippage=5; 
2009.03.31 11:49:08	_Close_ALL_Orders EURUSD,M15: loaded successfully
*/


//+------------------------------------------------------------------+
//|                                             _CloseAllBuySell.mq4 |
//|                                           "  " |
//|             Buy  Sell    |
//|                           Bookkeeper, 2006, yuzefovich@gmail.com |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
//#property show_confirm
extern int    Slippage      = 5;     // 
int start()
{
  bool   Result;
  int    i,Pos,Error,Total;
  //----
  Total=OrdersTotal();
  //if(Total>0)
  //{
    for(i=Total-1; i>=0; i--)
    {
      while(!IsTradeAllowed()) Sleep(ISTRADEALLOWED_POLLMSECS);  //RED=STOP - GREEN=GO!

      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)==true)
      {
        Pos=OrderType();
        Result = false;
        for(int iRetry=1;Result==false&&iRetry<=RETRY_MAX;iRetry++)
        {
          //if(Pos==OP_BUY || Pos==OP_SELL) //  Buy  Sell
          //{
          if(Pos==OP_BUY)
          Result=OrderClose(OrderTicket(),
                            OrderLots(),
                            //Bid,
                            MarketInfo(OrderSymbol(),MODE_BID),  //could be any chart...
                            Slippage,
                            CLR_NONE);
          //else
          else if(Pos==OP_SELL)
          Result=OrderClose(OrderTicket(),
                            OrderLots(),
                            //Ask,
                            MarketInfo(OrderSymbol(),MODE_ASK),
                            Slippage,
                            CLR_NONE);
          else
          Result=OrderDelete(OrderTicket());

          if(Result!=true)
          {
             Error=GetLastError();
             //Print("LastError = ",Error);
             Print("<<CLOSE_FAILURE>> #",OrderTicket(),", OrderType=",sOrderType(Pos)
                   ,", Retry.",iRetry,", LastError = ",Error," = \"",ErrorDescription(Error),"\"");
          }
          //else Error=0;
          //}
        }//for(iRetry..
      }
    }//for(i=Total-1..
//  }//total>0

  return(0);

}//start()


